hpp-core: hpp::core::SubchainPath Class Reference

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::core::SubchainPath Class Reference
Path

`#include <hpp/core/subchain-path.hh>`

Inheritance diagram for hpp::core::SubchainPath:
[legend]
Collaboration diagram for hpp::core::SubchainPath:
[legend]

## Public Types
typedef Path | parent_t

## Public Member Functions
virtual | ~SubchainPath ()
virtual PathPtr_t | copy () const
| Return a shared pointer to a copy of this.
virtual PathPtr_t | copy (const ConstraintSetPtr_t &constraints) const
virtual bool | impl_compute (ConfigurationOut_t result, value_type param) const
| Function evaluation without applying constraints.
Configuration_t | initial () const
| Get the initial configuration.
Configuration_t | end () const
| Get the final configuration.
void | dofExtract (ConfigurationIn_t qin, ConfigurationOut_t qout) const
Public Member Functions inherited from hpp::core::Path
virtual | ~Path ()
| Destructor.
template<class T >
shared_ptr< T > | as (void)
| Static cast into a derived type.
template<class T >
shared_ptr< const T > | as (void) const
| Static cast into a derived type.
PathPtr_t | extract (const interval_t &subInterval) const
PathPtr_t | extract (const value_type &tmin, const value_type &tmax) const
virtual PathPtr_t | reverse () const
Configuration_t | eval (const value_type &time, bool &success) const
| Configuration at time.
bool | eval (ConfigurationOut_t result, const value_type &time) const
| Configuration at time.
bool | at (const value_type &time, ConfigurationOut_t result) const
| Get the configuration at a parameter without applying the constraints.
void | derivative (vectorOut_t result, const value_type &time, size_type order) const
void | velocityBound (vectorOut_t result, const value_type &t0, const value_type &t1) const
size_type | outputSize () const
| Get size of configuration space.
size_type | outputDerivativeSize () const
| Get size of velocity.
const interval_t & | timeRange () const
| Get interval of definition.
virtual value_type | length () const
| Get length of definition interval.
const ConstraintSetPtr_t & | constraints () const
| Get constraints the path is subject to.
const interval_t & | paramRange () const
const TimeParameterizationPtr_t & | timeParameterization () const
| Get the time parameterization function.
void | timeParameterization (const TimeParameterizationPtr_t &tp, const interval_t &tr)
| Set the time parameterization function.

## Static Public Member Functions
static SubchainPathPtr_t | create (const PathPtr_t &original, const segments_t &confIntervals, const segments_t &velIntervals)
static SubchainPathPtr_t | createCopy (const SubchainPathPtr_t &path)
static SubchainPathPtr_t | createCopy (const SubchainPathPtr_t &path, const ConstraintSetPtr_t &constraints)

## Protected Member Functions
virtual std::ostream & | print (std::ostream &os) const
| Print path in a stream.
| SubchainPath (const PathPtr_t &original, const segments_t &confIntervals, const segments_t &velIntervals)
| SubchainPath (const SubchainPath &path)
| SubchainPath (const SubchainPath &path, const ConstraintSetPtr_t &constraints)
void | init (SubchainPathPtr_t self)
Protected Member Functions inherited from hpp::core::Path
| Path (const interval_t &interval, size_type outputSize, size_type outputDerivativeSize, const ConstraintSetPtr_t &constraints)
| Path (const interval_t &interval, size_type outputSize, size_type outputDerivativeSize)
| Path (const Path &path)
| Copy constructor.
| Path (const Path &path, const ConstraintSetPtr_t &constraints)
| Copy constructor with constraints.
void | init (const PathWkPtr_t &self)
void | constraints (const ConstraintSetPtr_t &constraint)
virtual void | checkPath () const
| Should be called by child classes after having init.
void | timeRange (const interval_t &timeRange)
value_type | paramLength () const
Configuration_t | configAtParam (const value_type &param, bool &success) const
virtual void | impl_derivative (vectorOut_t derivative, const value_type &param, size_type order) const
virtual void | impl_velocityBound (vectorOut_t bound, const value_type &param0, const value_type &param1) const
virtual PathPtr_t | impl_extract (const interval_t &paramInterval) const
| Virtual implementation of extract.
| Path ()

## Additional Inherited Members
Protected Attributes inherited from hpp::core::Path
interval_t | paramRange_
| Interval of parameters.

## Detailed Description

Result of the selection of some configuration parameter of an original path

Note
  Decorator design pattern

Todo:
  the configuration parameter cannot be rearranged.

## Member Typedef Documentation

## ◆ parent_t

typedef Path hpp::core::SubchainPath::parent_t

## Constructor & Destructor Documentation

## ◆ ~SubchainPath()

virtual hpp::core::SubchainPath::~SubchainPath | ( |  | ) |
| inlinevirtual

## ◆ SubchainPath() [1/3]

hpp::core::SubchainPath::SubchainPath | ( | const PathPtr_t & | original,
|  | const segments_t & | confIntervals,
|  | const segments_t & | velIntervals
| ) |  |
| inlineprotected

Constructor

Parameters

  original | Path to extract,
  confIntervals | of the configuration parameters to be extracted
  velIntervals | of the configuration parameters to be extracted

## ◆ SubchainPath() [2/3]

hpp::core::SubchainPath::SubchainPath | ( | const SubchainPath & | path | ) |
| inlineprotected

## ◆ SubchainPath() [3/3]

hpp::core::SubchainPath::SubchainPath | ( | const SubchainPath & | path,
|  | const ConstraintSetPtr_t & | constraints
| ) |  |
| inlineprotected

## Member Function Documentation

## ◆ copy() [1/2]

virtual PathPtr_t hpp::core::SubchainPath::copy | ( |  | ) | const
| inlinevirtual

Return a shared pointer to a copy of this.

Implements hpp::core::Path.

## ◆ copy() [2/2]

virtual PathPtr_t hpp::core::SubchainPath::copy | ( | const ConstraintSetPtr_t & | constraints | ) | const
| inlinevirtual

Return a shared pointer to a copy of this and set constraints

Parameters

  constraints | constraints to apply to the copy

Precondition
  *this should not have constraints.

Implements hpp::core::Path.

## ◆ create()

static SubchainPathPtr_t hpp::core::SubchainPath::create | ( | const PathPtr_t & | original,
|  | const segments_t & | confIntervals,
|  | const segments_t & | velIntervals
| ) |  |
| inlinestatic

Constructor

Parameters

  original | Path to extract,
  confIntervals | of the configuration parameters to be extracted
  velIntervals | of the configuration parameters to be extracted

## ◆ createCopy() [1/2]

static SubchainPathPtr_t hpp::core::SubchainPath::createCopy | ( | const SubchainPathPtr_t & | path | ) |
| inlinestatic

## ◆ createCopy() [2/2]

static SubchainPathPtr_t hpp::core::SubchainPath::createCopy | ( | const SubchainPathPtr_t & | path,
|  | const ConstraintSetPtr_t & | constraints
| ) |  |
| inlinestatic

## ◆ dofExtract()

void hpp::core::SubchainPath::dofExtract | ( | ConfigurationIn_t | qin,
|  | ConfigurationOut_t | qout
| ) |  | const
| inline

## ◆ end()

Configuration_t hpp::core::SubchainPath::end | ( |  | ) | const
| inlinevirtual

Get the final configuration.

Implements hpp::core::Path.

## ◆ impl_compute()

virtual bool hpp::core::SubchainPath::impl_compute | ( | ConfigurationOut_t | configuration,
|  | value_type | param
| ) |  | const
| inlinevirtual

Function evaluation without applying constraints.

Returns
  true if everything went good.

Implements hpp::core::Path.

## ◆ init()

void hpp::core::SubchainPath::init | ( | SubchainPathPtr_t | self | ) |
| inlineprotected

## ◆ initial()

Configuration_t hpp::core::SubchainPath::initial | ( |  | ) | const
| inlinevirtual

Get the initial configuration.

Implements hpp::core::Path.

## ◆ print()

virtual std::ostream & hpp::core::SubchainPath::print | ( | std::ostream & | os | ) | const
| inlineprotectedvirtual

Print path in a stream.

Reimplemented from hpp::core::Path.

The documentation for this class was generated from the following file:

- include/hpp/core/subchain-path.hh